import { ViewBase } from '../../libappbase/viewbase';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { ButtonProcessesContextMenuItem } from '../actionbarpages/abp.data';
import { AppMP } from '../appmp';
import { FormRouting } from '../forms/form.routing';

export class ViewRouting extends ViewBase implements UIWaitSOP {
  public readonly name = 'Routings';
  public readonly viewPath = 'Data > Processes > Routings';

  public formRouting = new FormRouting();

  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    // wait until abp data is visible
    await appMP.abpData.isVisible();
    // Open data action bar page
    await appMP.abpData.click();
    // Click on Routings submenu in Processes context menu
    await appMP.abpData.btnProcesses.clickDropdownAndSelectMenu(ButtonProcessesContextMenuItem.Routings);

    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    // Wait until Routing form is present
    await this.formRouting.waitUntilPresent();
  }
}
